--- ../tk4.1/unix/tkUnixDefault.h	Fri Feb 16 22:32:17 1996
+++ tkUnixDefault.h	Mon Jul  8 19:24:14 1996
@@ -12,6 +12,10 @@
  *
  * SCCS: @(#) tkUnixDefault.h 1.85 96/02/15 18:55:24
  */
+/*
+ * TkSTEP modifications Copyright by
+ * Alfredo K. Kojima
+ */
 
 #ifndef _TKUNIXDEFAULT
 #define _TKUNIXDEFAULT
@@ -29,22 +33,22 @@
 #define BLACK		"Black"
 #define WHITE		"White"
 
-#define NORMAL_BG	"#d9d9d9"
-#define ACTIVE_BG	"#ececec"
+#define NORMAL_BG	"#bfbfbf"
+#define ACTIVE_BG	"#ffffff"
 #define SELECT_BG	"#c3c3c3"
-#define TROUGH		"#c3c3c3"
-#define INDICATOR	"#b03060"
-#define DISABLED	"#a3a3a3"
+#define TROUGH		"#bfbfbf"
+#define INDICATOR	"#ffffff"
+#define DISABLED	"#636363"
 
 /*
  * Defaults for labels, buttons, checkbuttons, and radiobuttons:
  */
 
 #define DEF_BUTTON_ANCHOR		"center"
-#define DEF_BUTTON_ACTIVE_BG_COLOR	ACTIVE_BG
-#define DEF_BUTTON_ACTIVE_BG_MONO	BLACK
+#define DEF_BUTTON_ACTIVE_BG_COLOR	NORMAL_BG
+#define DEF_BUTTON_ACTIVE_BG_MONO	WHITE
 #define DEF_BUTTON_ACTIVE_FG_COLOR	BLACK
-#define DEF_BUTTON_ACTIVE_FG_MONO	WHITE
+#define DEF_BUTTON_ACTIVE_FG_MONO	BLACK
 #define DEF_BUTTON_BG_COLOR		NORMAL_BG
 #define DEF_BUTTON_BG_MONO		WHITE
 #define DEF_BUTTON_BITMAP		""
@@ -54,12 +58,12 @@
 #define DEF_BUTTON_DISABLED_FG_COLOR	DISABLED
 #define DEF_BUTTON_DISABLED_FG_MONO	""
 #define DEF_BUTTON_FG			BLACK
-#define DEF_BUTTON_FONT			"-Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*"
+#define DEF_BUTTON_FONT			"-Adobe-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*"
 #define DEF_BUTTON_HEIGHT		"0"
 #define DEF_BUTTON_HIGHLIGHT_BG		NORMAL_BG
 #define DEF_BUTTON_HIGHLIGHT		BLACK
 #define DEF_LABEL_HIGHLIGHT_WIDTH	"0"
-#define DEF_BUTTON_HIGHLIGHT_WIDTH	"2"
+#define DEF_BUTTON_HIGHLIGHT_WIDTH	"0"
 #define DEF_BUTTON_IMAGE		(char *) NULL
 #define DEF_BUTTON_INDICATOR		"1"
 #define DEF_BUTTON_JUSTIFY		"center"
@@ -98,7 +102,7 @@
 #define DEF_CANVAS_CURSOR		""
 #define DEF_CANVAS_HEIGHT		"7c"
 #define DEF_CANVAS_HIGHLIGHT_BG		NORMAL_BG
-#define DEF_CANVAS_HIGHLIGHT		BLACK
+#define DEF_CANVAS_HIGHLIGHT		WHITE
 #define DEF_CANVAS_HIGHLIGHT_WIDTH	"2"
 #define DEF_CANVAS_INSERT_BG		BLACK
 #define DEF_CANVAS_INSERT_BD_COLOR	"0"
@@ -149,7 +153,7 @@
 #define DEF_ENTRY_SELECT_BD_COLOR	"1"
 #define DEF_ENTRY_SELECT_BD_MONO	"0"
 #define DEF_ENTRY_SELECT_FG_COLOR	BLACK
-#define DEF_ENTRY_SELECT_FG_MONO	WHITE
+#define DEF_ENTRY_SELECT_FG_MONO	BLACK
 #define DEF_ENTRY_SHOW			(char *) NULL
 #define DEF_ENTRY_STATE			"normal"
 #define DEF_ENTRY_TAKE_FOCUS		(char *) NULL
@@ -168,7 +172,7 @@
 #define DEF_FRAME_CURSOR		""
 #define DEF_FRAME_HEIGHT		"0"
 #define DEF_FRAME_HIGHLIGHT_BG		NORMAL_BG
-#define DEF_FRAME_HIGHLIGHT		BLACK
+#define DEF_FRAME_HIGHLIGHT		WHITE
 #define DEF_FRAME_HIGHLIGHT_WIDTH	"0"
 #define DEF_FRAME_RELIEF		"flat"
 #define DEF_FRAME_TAKE_FOCUS		"0"
@@ -184,7 +188,7 @@
 #define DEF_LISTBOX_BORDER_WIDTH	"2"
 #define DEF_LISTBOX_CURSOR		""
 #define DEF_LISTBOX_EXPORT_SELECTION	"1"
-#define DEF_LISTBOX_FONT		"-Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*"
+#define DEF_LISTBOX_FONT		"-Adobe-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*"
 #define DEF_LISTBOX_FG			BLACK
 #define DEF_LISTBOX_HEIGHT		"10"
 #define DEF_LISTBOX_HIGHLIGHT_BG	NORMAL_BG
@@ -233,17 +237,17 @@
  */
 
 #define DEF_MENU_ACTIVE_BG_COLOR	ACTIVE_BG
-#define DEF_MENU_ACTIVE_BG_MONO		BLACK
+#define DEF_MENU_ACTIVE_BG_MONO		WHITE
 #define DEF_MENU_ACTIVE_BORDER_WIDTH	"2"
 #define DEF_MENU_ACTIVE_FG_COLOR	BLACK
-#define DEF_MENU_ACTIVE_FG_MONO		WHITE
+#define DEF_MENU_ACTIVE_FG_MONO		BLACK
 #define DEF_MENU_BG_COLOR		NORMAL_BG
 #define DEF_MENU_BG_MONO		WHITE
 #define DEF_MENU_BORDER_WIDTH		"2"
 #define DEF_MENU_CURSOR			"arrow"
 #define DEF_MENU_DISABLED_FG_COLOR	DISABLED
 #define DEF_MENU_DISABLED_FG_MONO	""
-#define DEF_MENU_FONT			"-Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*"
+#define DEF_MENU_FONT			"-Adobe-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*"
 #define DEF_MENU_FG			BLACK
 #define DEF_MENU_POST_COMMAND		""
 #define DEF_MENU_RELIEF			"raised"
@@ -259,10 +263,10 @@
  */
 
 #define DEF_MENUBUTTON_ANCHOR		"center"
-#define DEF_MENUBUTTON_ACTIVE_BG_COLOR	ACTIVE_BG
-#define DEF_MENUBUTTON_ACTIVE_BG_MONO	BLACK
+#define DEF_MENUBUTTON_ACTIVE_BG_COLOR	NORMAL_BG
+#define DEF_MENUBUTTON_ACTIVE_BG_MONO	WHITE
 #define DEF_MENUBUTTON_ACTIVE_FG_COLOR	BLACK
-#define DEF_MENUBUTTON_ACTIVE_FG_MONO	WHITE
+#define DEF_MENUBUTTON_ACTIVE_FG_MONO	BLACK
 #define DEF_MENUBUTTON_BG_COLOR		NORMAL_BG
 #define DEF_MENUBUTTON_BG_MONO		WHITE
 #define DEF_MENUBUTTON_BITMAP		""
@@ -270,7 +274,7 @@
 #define DEF_MENUBUTTON_CURSOR		""
 #define DEF_MENUBUTTON_DISABLED_FG_COLOR DISABLED
 #define DEF_MENUBUTTON_DISABLED_FG_MONO	""
-#define DEF_MENUBUTTON_FONT		"-Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*"
+#define DEF_MENUBUTTON_FONT		"-Adobe-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*"
 #define DEF_MENUBUTTON_FG		BLACK
 #define DEF_MENUBUTTON_HEIGHT		"0"
 #define DEF_MENUBUTTON_HIGHLIGHT_BG	NORMAL_BG
@@ -302,7 +306,7 @@
 #define DEF_MESSAGE_BORDER_WIDTH	"2"
 #define DEF_MESSAGE_CURSOR		""
 #define DEF_MESSAGE_FG			BLACK
-#define DEF_MESSAGE_FONT		"-Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*"
+#define DEF_MESSAGE_FONT		"-Adobe-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*"
 #define DEF_MESSAGE_HIGHLIGHT_BG	NORMAL_BG
 #define DEF_MESSAGE_HIGHLIGHT		BLACK
 #define DEF_MESSAGE_HIGHLIGHT_WIDTH	"0"
@@ -320,7 +324,7 @@
  */
 
 #define DEF_SCALE_ACTIVE_BG_COLOR	ACTIVE_BG
-#define DEF_SCALE_ACTIVE_BG_MONO	BLACK
+#define DEF_SCALE_ACTIVE_BG_MONO	WHITE
 #define DEF_SCALE_BG_COLOR		NORMAL_BG
 #define DEF_SCALE_BG_MONO		WHITE
 #define DEF_SCALE_BIG_INCREMENT		"0"
@@ -343,23 +347,23 @@
 #define DEF_SCALE_REPEAT_INTERVAL	"100"
 #define DEF_SCALE_RESOLUTION		"1"
 #define DEF_SCALE_TROUGH_COLOR		TROUGH
-#define DEF_SCALE_TROUGH_MONO		WHITE
+#define DEF_SCALE_TROUGH_MONO		BLACK
 #define DEF_SCALE_SHOW_VALUE		"1"
-#define DEF_SCALE_SLIDER_LENGTH		"30"
+#define DEF_SCALE_SLIDER_LENGTH		"20"
 #define DEF_SCALE_SLIDER_RELIEF		"raised"
 #define DEF_SCALE_STATE			"normal"
 #define DEF_SCALE_TAKE_FOCUS		(char *) NULL
 #define DEF_SCALE_TICK_INTERVAL		"0"
 #define DEF_SCALE_TO			"100"
 #define DEF_SCALE_VARIABLE		""
-#define DEF_SCALE_WIDTH			"15"
+#define DEF_SCALE_WIDTH			"14"
 
 /*
  * Defaults for scrollbars:
  */
 
-#define DEF_SCROLLBAR_ACTIVE_BG_COLOR	ACTIVE_BG
-#define DEF_SCROLLBAR_ACTIVE_BG_MONO	BLACK
+#define DEF_SCROLLBAR_ACTIVE_BG_COLOR	NORMAL_BG
+#define DEF_SCROLLBAR_ACTIVE_BG_MONO	WHITE
 #define DEF_SCROLLBAR_ACTIVE_RELIEF	"raised"
 #define DEF_SCROLLBAR_BG_COLOR		NORMAL_BG
 #define DEF_SCROLLBAR_BG_MONO		WHITE
@@ -369,16 +373,16 @@
 #define DEF_SCROLLBAR_EL_BORDER_WIDTH	"-1"
 #define DEF_SCROLLBAR_HIGHLIGHT_BG	NORMAL_BG
 #define DEF_SCROLLBAR_HIGHLIGHT		BLACK
-#define DEF_SCROLLBAR_HIGHLIGHT_WIDTH	"2"
+#define DEF_SCROLLBAR_HIGHLIGHT_WIDTH	"0"
 #define DEF_SCROLLBAR_JUMP		"0"
 #define DEF_SCROLLBAR_ORIENT		"vertical"
-#define DEF_SCROLLBAR_RELIEF		"sunken"
+#define DEF_SCROLLBAR_RELIEF		"flat"
 #define DEF_SCROLLBAR_REPEAT_DELAY	"300"
 #define DEF_SCROLLBAR_REPEAT_INTERVAL	"100"
 #define DEF_SCROLLBAR_TAKE_FOCUS	(char *) NULL
 #define DEF_SCROLLBAR_TROUGH_COLOR	TROUGH
-#define DEF_SCROLLBAR_TROUGH_MONO	WHITE
-#define DEF_SCROLLBAR_WIDTH		"15"
+#define DEF_SCROLLBAR_TROUGH_MONO	BLACK
+#define DEF_SCROLLBAR_WIDTH		"16"
 
 /*
  * Defaults for texts:
@@ -404,12 +408,12 @@
 #define DEF_TEXT_PADX			"1"
 #define DEF_TEXT_PADY			"1"
 #define DEF_TEXT_RELIEF			"sunken"
-#define DEF_TEXT_SELECT_COLOR		SELECT_BG
-#define DEF_TEXT_SELECT_MONO		BLACK
+#define DEF_TEXT_SELECT_COLOR		NORMAL_BG
+#define DEF_TEXT_SELECT_MONO		WHITE
 #define DEF_TEXT_SELECT_BD_COLOR	"1"
 #define DEF_TEXT_SELECT_BD_MONO		"0"
 #define DEF_TEXT_SELECT_FG_COLOR	BLACK
-#define DEF_TEXT_SELECT_FG_MONO		WHITE
+#define DEF_TEXT_SELECT_FG_MONO		BLACK
 #define DEF_TEXT_SET_GRID		"0"
 #define DEF_TEXT_SPACING1		"0"
 #define DEF_TEXT_SPACING2		"0"